use postgres::{Client, NoTls};
use std::{
    env::args,
    fs::File,
    io::{BufRead, BufReader, Write},
};

fn generate_file(website_name: &str) {
    let mut client = Client::connect("host=192.168.0.10 port=28945 user=hentai password=h99nqaNPhpfbuuhCDwQXLpZAnoVTjSQP7taoqmQhpzc2rPLVC4JUAKxAHfuuhuU9", NoTls).unwrap();
    let output = client
        .query_one("SELECT website_exists($1);", &[&website_name])
        .unwrap();

    let result: bool = output.get(0);
    if result == false {
        panic!("Invalid website_name");
    }

    let filename = format!("{website_name}_generated.txt");
    let mut file = match File::create(filename) {
        Ok(file) => file,
        Err(error) => {
            let message = error.to_string();
            panic!("Problem opening the file: {message}");
        }
    };

    let sqlstmt = format!("SELECT * FROM get_urls_and_paths('{}');", website_name);
    let output = client.query(&sqlstmt, &[]).unwrap();

    for row in output {
        let url: String = row.get(0);
        let folder_path: String = row.get(1);

        write!(file, "{} # {}\n", url, folder_path).unwrap();
    }
}

fn import_file(filename: &str) {
    let file = File::open(filename).unwrap();
    let reader_iter = BufReader::new(file).lines();
    let mut client = Client::connect("host=192.168.0.10 port=28945 user=hentai password=h99nqaNPhpfbuuhCDwQXLpZAnoVTjSQP7taoqmQhpzc2rPLVC4JUAKxAHfuuhuU9", NoTls).unwrap();

    for line in reader_iter {
        let line = line.unwrap();
        if !line.contains("#") {
            let output = client.query_one("SELECT insert_url($1)", &[&line]).unwrap();

            let result: i32 = output.get(0);
            dbg!(result);
        }
    }
}

fn main() {
    let args: Vec<String> = args().collect();
    dbg!(&args);

    if args.len() != 3 {
        panic!("Too many or too few arguments");
    }

    let operation: &str = args[1].as_str();

    match operation {
        "generate" => generate_file(&args[2]),
        "import" => import_file(&args[2]),
        _ => panic!("Invalid argument"),
    }
}
